#include "snake.h"

/* external data */
extern cell fruit;

/* external functions */
extern void move_cell ( cell *from, int dir, int steps );
extern snake *snake_make ( void );
extern void move_cell ( cell *from, int dir, int steps );
extern int register_player ( snake * );

/* private functions */
static void myplay ( snake *mysnake );


int module_init ()
{
	snake *mysnake;
	int player;

	mysnake = snake_make ();
	mysnake->play = &myplay;
	
	player = register_player (mysnake);

	return 0;
}

static void myplay ( snake *mysnake )
{
	static int vdir = UP;
	static int hdir = LEFT;
	static cell oldfruit;
	static int timetoturn = 0;
	static int turn = 0;


	/* change default vdir and hdir if fruit has changed position */
	if ( memcmp(&fruit,&oldfruit,sizeof(cell)) ) {
		memcpy (&oldfruit, &fruit, sizeof(cell));
		vdir = (vdir == UP) ? DOWN : UP;
		hdir = (hdir == LEFT) ? RIGHT : LEFT;
	}

	/* change timetoturn */
	if ( mysnake->length >= 8 ) {
		timetoturn = (mysnake->length/3)+1;
	} else {
		timetoturn = (ARENA_WIDTH+ARENA_HEIGHT)/2;
	}
		

	/* catch fruit if hortogonal */
	if ( mysnake->head->cell.x == fruit.x ) {
		mysnake->dir = vdir;
		return;
	}
	else if ( mysnake->head->cell.y == fruit.y ) {
		mysnake->dir = hdir;
		return;
	}

	/* time to turn */
	if ( ++turn >= timetoturn ) {
		mysnake->dir++;
		if ( mysnake->dir >= 4 ) mysnake->dir = 0;
		turn = 0;
	}

}


