#include "include/snake.h"

/* public data */
WINDOW *pausewin;
WINDOW *arenawin;

/* public functions */
int init_graphics (void);

/* private functions */
static int init_screen (void);
static int init_colors (void);

int init_graphics ()
{

	char pausemsg[] = " GAME PAUSED, press any key to continue ";

	/* init screen */
	if ( ! init_screen() ) return 0;

	/* make pause window */
	pausewin = newwin(1, strlen(pausemsg)+1, LINES-1, 2);
	mvwaddstr(pausewin, 0, 0, pausemsg);

	/* make arena window */
	arenawin = newwin(0,0,0,0);
	box(arenawin, ACS_VLINE, ACS_HLINE);

	/* init colors */
	if ( has_colors() ) init_colors();

	return 1;

}

/* initialize colors */
static int init_colors()
{
	int i;

	/* use colors for background and player looks */
	start_color();

	/* init color pairs */
	for ( i=1; i<8; i++ ) init_pair(i, i, 0);

	return 1;
}

/* initialize the screen  */
static int init_screen ()
{
	/* initialize the COLS and LINES vars */
	initscr();

	/* make cursor invisible */
	if ( curs_set(0) == ERR ) return 0;	

	/* make each carachter break input reads */
	if ( cbreak() == ERR ) return 0;			

	/* make getch() be a non-blocking call  */
	if ( nodelay(stdscr, TRUE) == ERR ) return 0;

	/* redraw completely on refresh */
	clearok(stdscr, TRUE);

	/* success */
	return 1;
}



